#=========================================================================
#
#  Ficname     : CreateNYCalendar.ksh
#
#  Redacteur   : JF.GONZALEZ GARCIA
#  Copyright   : 
#  date        : 02 decembre 2014
#  Projet      : ControlM creation des calendriers new year
#  Version     : 1.0
#
#  Description :
#
#  Ce script permet d apres une liste des calendriers existants 
#  de les refaire pour la nouvelle annnee
#----------------- exporter les calendriers Controlm d un DATACENTER
#
#  extraire calendar avec
# exportdefcal -HOST hermes -USERNAME ecsuser -PASSWORD password -ARG_FILE ExportCalendar.xml -OUT_FILE CalendarCCMSA.txt
#
# <?xml version="1.0" encoding="UTF-8"?>
# <!DOCTYPE TERMS SYSTEM "terms.dtd">
# <TERMS>
#       <TERM>
#               <PARAM NAME="DATACENTER" OP="EQ" VALUE="CCMSA"/>
#               <PARAM NAME="CALENDAR" OP="LIKE" VALUE="ALL*"/>
#       </TERM>
# </TERMS>
#
#--------------- Charger calendar
#
#  defcal -HOST hermes -USERNAME ecsuser -PASSWORD password -SRC_FILE CalendarCCMSA.txt
#
# ---------------- Upload calendar
#  ecs cli -U ecsuser -P password -H hermes -CAL_UPLOAD CCMSA ALLD
#
#------------------ Por deleter calendar
#  sqlplus
#      delete from df_years where year='2005'; 
#
#  Pensez a faire le force UPLOAD sous Control/Desktop pour tous les calendriers touches
#
#------------------------------------------------------------------------------------------
#
#############################################################################################
#
#  fichier des donnees de l annee a traiter a renseigner avant envoi du traitement
#
#############################################################################################
#
 . ./ParmCreateNYCalendarNAT.txt

#############################################################
#
# FONCTIONS
#
#############################################################
#
Jours_Feries()
{
 echo $jf | grep -w $qtiem 1>/dev/null && return 0 || return 1
}

Vendredi_Maintenance()
{
 echo $vm | grep -w $qtiem 1>/dev/null && return 0 || return 1
}

Jour()
{
 test $qtiem -eq $1 && return 0 || return 1
}

Jour_Precedent()
{
  lgval=${#val}
  (( lgval-=1 ))
  if test $lgval -gt 0 
   then
     val=$( echo ${val} | cut -c1-${lgval} )
     val=${val}"${1}"
  fi
}
#
#############################################################
#---------------- Debut script
#############################################################
#
set -a

#---------- Fichier xml contenant les calendriers a traiter
FicCalendarIn=$1
FicCalendarOut=$2
  if test $# -ne 2
     then 
         echo " Manque Fichiers en entree contenant les calendriers extraits et le fichier pour les calendriers a charger"
         exit 9
  fi

  if test ! -f $FicCalendarIn
    then 
        echo " Fichier $FicCalendarIn inconnu !!!"
         exit 9
  fi

#---------- annee a traiter annee en cours + 1
annee=$( date +%Y )
(( annee+=1 ))

#------------ zones pour bilan
Edit_Zones="\
 NuM;N0;4\
 DATACENTER;DataCenter;20\
 NAME;Calendrier;15\
 TYPE;Type;10\
 CHARGER;Charg;6\
 REGLE;Avec_Regle;10\
 DESCRIPTION;Description;60"

COMMUN=/environnements/...

 Souli=";=;$( $COMMUN/Edit_Tableau.exe longl ${Edit_Zones} )"
NuM=0

#======== Fonction Edit Bilan
cat << @EOFF

Si colonne Charg = Non   => ce calendrier n'a pas t pris en compte (  faire  la mano )
Si colonne Avec Regle = Non  => il faut revoir les rgles de mise au plan par l'interface ControlM/Desktop

@EOFF
     $COMMUN/Edit_Tableau.exe souli ${Souli}
     $COMMUN/Edit_Tableau.exe titre ${Edit_Zones}
     $COMMUN/Edit_Tableau.exe souli ${Souli}

#-----------------------------------------------------------
#----------- Trt calendar
#-----------------------------------------------------------
#
#--- debut fichier xml pour chargement

cat << @EOFF > ${FicCalendarOut}
<?xml version='1.0' encoding='ISO-8859-1' ?>
<!DOCTYPE DEFCAL SYSTEM "$( echo ~)/appl/ecs/cli/resource/defcal.dtd">
 <DEFCAL >
@EOFF

#
#---------- Lecture fichier extract calendrier d un DATACENTER
# en recuperer les variables NAME TYPE DESCRIPTION
#
#--Verif nbre NAME= nbre DESCRIPTION= sinon probleme
nbrNAME=$( grep -wv CALENDAR ${FicCalendarIn}  |grep -wc 'NAME=' )
nbrDESCRIPTION=$( grep -wv CALENDAR ${FicCalendarIn}  |grep -wc 'DESCRIPTION=' )

test ${nbrNAME} -ne ${nbrDESCRIPTION} && echo "Probleme dans ${FicCalendarIn} difference dans nbre NAME ${nbrNAME} et DESCRIPTION ${nbrDESCRIPTION} " && exit 9

##egrep "\<CALENDAR|NAME=\"$( date +%Y )\"" ${FicCalendarIn} | awk '{ if ( $0 ~ /CALENDAR/ ) { ligne=$2";"$3";"$4";"$7 } ; if ( $0 ~ /DESCRIPTION/ ) { ligne=ligne""substr($0,429) ; print ligne ; ligne="" }}' | sed "s/>//g;s/\///g;s/\<//g" | while read ligne
egrep "\<CALENDAR|NAME=\"$( date +%Y )\"" ${FicCalendarIn} | \
awk '{ 
      if ( $0 ~ /CALENDAR/ ) { ligne=$2";"$3";"$4";"$8 }
      if ( $0 ~ /DESCRIPTION/ )
         { 
           i=split($0,T,"=")
           ligne=ligne"DESCRIPTION="T[3] ; print ligne ; ligne="" }
}' | sed "s/>//g;s/\///g;s/\<//g;s#/##g;s#>##g;s/ NAME$//" | while read ligne
do
#-------- charger ces variables
  eval $ligne

#---- var trt
month=0
val=
qtiem=0
REGLE=Non
CHARGER=Non

#------ def premier samedi et premier dimanche
psam=6
(( psam-=fday ))
(( psam+=1 ))

pdim=$psam
(( pdim+=1 ))

pven=$psam
(( pven-=1 ))

pmar=$psam
(( pmar+=3 ))

case ${fday} in
            0|1|2)    (( pmar-=7 )) ;;
esac

svmonth=1
nbmar=0

#--------- trt des calendriers
## case ${NAME} in
  ### VM*|WD|ALLD|FERIES*|DIM-VEN)
#-- ne pas traiter les periodiques ca pose probleme au chargement
case ${TYPE} in
  Regular)

#------- boucle par nbre de jour dans le mois 
# pour recuperer pour chaque jour du mois si oui ou non 
# mise au plan ctm
#
  for i in $daymonth
  do
    (( month+=1 ))
    t=0
#---- chaque jour du moiS
    while [ $t -lt $i ]
     do
         (( t+=1 ))
         (( qtiem+=1 ))

#---- variable jour du mois par defaut positionner a NON
     monthday[${t}]=N

##
##---------------------------------------------------------------
#----- suivant calendrier traite effectuer les regles de planif
##---------------------------------------------------------------
##

#------- si REGLE existe = Oui sinon Non
   REGLE=Oui
   CHARGER=Oui
    
     case ${NAME} in

       ALLD|MSAALL)
#-------- regle TOUS LES JOURS
           monthday[${t}]=Y
                   ;;

       WORKDAYS)
#-------- regle DU LUNDI AU VENDREDI
           monthday[${t}]=Y
           Jour $psam && monthday[${t}]=N
           Jour $pdim && monthday[${t}]=N
           Jours_Feries && monthday[${t}]=N
                   ;;

       MSAWORK)
#-------- regle DU LUNDI AU VENDREDI JOURS FERIES EXCLUS
           monthday[${t}]=Y
           Jour $psam && monthday[${t}]=N
           Jour $pdim && monthday[${t}]=N
           Jours_Feries && monthday[${t}]=N
                   ;;

       FERIES)
#-------- regle tous sauf JOURS FERIES
           monthday[${t}]=Y
           Jours_Feries && monthday[${t}]=N
                   ;;

       MSAFERIE)
#-------- regle JOURS FERIES + SAMEDI DIMANCHE
           Jours_Feries && monthday[${t}]=Y
           Jour $psam && monthday[${t}]=Y
           Jour $pdim && monthday[${t}]=Y
                   ;;

       MSACTT|MSAWORKD|'DIM&gt;JEU')
#-------- regle DU DIMANCHE AU JEUDI sauf FERIES MSA
           monthday[${t}]=Y
           Jour $pven && monthday[${t}]=N
           Jour $psam && monthday[${t}]=N
           Jours_Feries && monthday[${t}]=N
                   ;;

       DRM-FER-1)
#-------- regle TOUS INCLUS FERIES-1 et FERIES EXCLUS
           monthday[${t}]=Y
           Jours_Feries && Jour_Precedent N
           Jours_Feries && monthday[${t}]=N
                   ;;

       TSCS09JO)
#-------- regle tous LES 2eme MARDIS du MOIS
           Jour $pmar
           if test $? -eq 0
             then
              (( nbmar+=1 ))
               if test $svmonth -eq $month -a $nbmar -eq 2 
                then
                   monthday[${t}]=Y
                   svmonth=month
               fi
           fi
                   ;;
    esac

#
#------ incrementer samedi et dimanche suivant
#
    test $qtiem -eq $psam && (( psam+=7 ))
    test $qtiem -eq $pdim && (( pdim+=7 ))
    test $qtiem -eq $pven && (( pven+=7 ))
    test $qtiem -eq $pmar && (( pmar+=7 ))

#
#------- variable contenant les jours de planif du calendrier traiter
#
    val=${val}""${monthday[${t}]}

     done

     nbmar=0
     
  done

#
#-------- fin de traitement d un calendrier recuperer 
# valeur de chaque jour du mois
#
cat << @EOFF >> ${FicCalendarOut}
  <CALENDAR NAME="${NAME}" TYPE="${TYPE}" DATACENTER="${DATACENTER}">
   <YEAR DAYS="${val}" NAME="${annee}" DESCRIPTION="${DESCRIPTION}"/>
  </CALENDAR>
@EOFF
     ;;
esac

#--------- edt bilan
     (( NuM+=1 ))
     $COMMUN/Edit_Tableau.exe ligne ${Edit_Zones}

done

#
##################################################################
#---------------- Fin traitement
##################################################################
#
#--------- fermer tableau bilan
     $COMMUN/Edit_Tableau.exe souli ${Souli}

#---------- fin fionchier de chargement
cat << @EOFF >> ${FicCalendarOut}
 </DEFCAL>
@EOFF

#
#-------------------- liste contenu du fichier xml contenant 
# les nouvelles donnes a charger
## cat ${FicCalendarOut}

#
#---------------------- Charger calendrier sur DATACENTER
#  commande utilitaire permettant de charger ces nouveaux calendriers
echo "\n Commande a lancer pour charger les nouveaux calendriers \n"
echo "defcal -HOST ${HOST} -USERNAME ${USERNAME} -PASSWORD ${PASSWORD} -SRC_FILE ${FicCalendarOut}"

exit
